package de.mmadler.filecopy.utils;

import java.util.ArrayList;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class Configuration {
	private String _defaultDirectory;
	private int _rememberDirectories;
	private OverwriteMode _overWriteMode;
	private OnErrorMode _onErrorMode;
	private boolean _keepTimestamp;
	private boolean _trayIcon;
	private boolean _writeLog;
	
	private ArrayList<String> _targetDirectories;
	
	public Configuration() {
		_defaultDirectory = "";
		_rememberDirectories = 10;
		_overWriteMode = OverwriteMode.Ask;
		_onErrorMode = OnErrorMode.Abort;
		_keepTimestamp = true;
		_trayIcon = false;
		_writeLog = false;
		
		_targetDirectories = new ArrayList<String>();
	}
	
	public String getDefaultDirectory() {
		return _defaultDirectory;
	}
	public void setDefaultDirectory(String defaultDirectory) {
		_defaultDirectory = defaultDirectory;
	}

	public int getRememberDirectories() {
		return _rememberDirectories;
	}

	public void setRememberDirectories(String rememberDirectories) {
		_rememberDirectories = Integer.valueOf(rememberDirectories);
		if(_rememberDirectories<0 || _rememberDirectories>100) _rememberDirectories = 10;
	}

	public OverwriteMode getOverWriteMode() {
		return _overWriteMode;
	}
	public void setOverWriteMode(OverwriteMode overWriteMode) {
		_overWriteMode = overWriteMode;
	}
	
	public OnErrorMode getOnErrorMode() {
		return _onErrorMode;
	}
	public void setOnErrorMode(OnErrorMode onErrorMode) {
		_onErrorMode = onErrorMode;
	}

	public boolean keepTimestamp() {
		return _keepTimestamp;
	}
	public boolean getKeepTimestamp() {
		return _keepTimestamp;
	}
	public void setKeepTimestamp(boolean keepTimestamp) {
		_keepTimestamp = keepTimestamp;
	}
	
	public boolean showTrayIcon() {
		return _trayIcon;
	}
	public boolean getTrayIcon() {
		return _trayIcon;
	}
	public void setTrayIcon(boolean trayIcon) {
		_trayIcon = trayIcon;
	}
	
	public boolean writeLog() {
		return _writeLog;
	}
	public boolean getWriteLog() {
		return _writeLog;
	}
	public void setWriteLog(boolean writeLog) {
		_writeLog = writeLog;
	}

	@XmlElementWrapper(name = "targetDirectories")
	@XmlElement(name = "directory")
	public ArrayList<String> getTargetDirectories() {
		return _targetDirectories;
	}
	public void setTargetDirectories(ArrayList<String> targetDirectories) {
		_targetDirectories = targetDirectories;
	}
}
