package de.mmadler.filecopy.utils;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

public class ConfigurationReader {
	private static final String configFile = "FileCopy.xml";
	
	//private static final Logger logger = LoggerFactory.getLogger(ConfigurationReader.class);

	public static Configuration readConfiguration() {
		Configuration config = new Configuration();
		FileInputStream configStream = null;
		try {
			configStream = new FileInputStream(configFile);
			JAXBContext jc;
			Unmarshaller un;
			jc = JAXBContext.newInstance(Configuration.class);
			un = jc.createUnmarshaller();
			Configuration element = (Configuration) un.unmarshal(configStream);
			config = element;
		} catch (JAXBException e) {
			//logger.error("Error reading config file.", e);
			try {
				configStream.close();
			} catch (IOException e1) {
			}
		} catch (FileNotFoundException e) {
		}
		return config;
	}
	
	public static void writeConfiguration(Configuration config) {
		OutputStream outStream = null;
		try {
			try {
				JAXBContext jContext = JAXBContext.newInstance(Configuration.class);
				Marshaller m = jContext.createMarshaller();
				m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
				outStream = new FileOutputStream(configFile);
				m.marshal(config, outStream);
				outStream.close();
			} catch (JAXBException e) {
				//logger.error("Failed to write config file.", e);
			} catch (FileNotFoundException e) {
				//logger.error("Failed to write config file.", e);
			} finally {
				if(outStream != null) outStream.close();
			}
		} catch (IOException e) {
			//logger.error("Closing file failed.", e);
		}
	}
}
